<template>
  <div>
    <v-tooltip bottom>
      <template v-slot:activator="{ on }">
        <v-btn fab small color="primary" @click.stop="openDialog" v-on="on">
          <v-icon>save</v-icon>
        </v-btn>
      </template>
      <span>Save as insight</span>
    </v-tooltip>

    <v-dialog v-model="dialog" width="800">
      <v-card>
        <v-container fluid>
          <v-layout row wrap fill-height>
            <v-flex xs12>
              <p class="headline">Save your insight</p>
              <p class="h1">
                <span class="font-weight-bold">Dataset:</span>
                <span>{{ " " + currentDataset.name }}</span>
              </p>
            </v-flex>
            <v-flex xs6 v-if="graphImage">
              <v-img :src="graphImage" alt="Graph snapshot" />
            </v-flex>
            <v-flex xs6 v-if="matrixImage">
              <v-img :src="matrixImage" alt="Matrix snapshot" />
            </v-flex>
            <v-flex xs6 class="pa-2 pt-4">
              <v-text-field
                label="Your name"
                clearable
                v-model="author"
              ></v-text-field>
            </v-flex>
            <v-flex xs6 class="pa-2 pt-4">
              <v-text-field
                label="Title"
                clearable
                v-model="title"
              ></v-text-field>
            </v-flex>
            <v-flex xs12 class="pa-2">
              <v-textarea
                label="Your observation"
                placeholder="Tell everyone what you found!"
                v-model="text"
                auto-grow
              ></v-textarea>
            </v-flex>
            <v-flex>
              <v-btn color="success" @click="saveInsight" :loading="loading"
                >Save</v-btn
              >
            </v-flex>
          </v-layout>
        </v-container>
      </v-card>
    </v-dialog>
  </div>
</template>

<script>
import { mapState } from "vuex";
export default {
  data() {
    return {
      dialog: false,
      graph: undefined,
      matrix: undefined,
      graphImage: undefined,
      matrixImage: undefined,
      loading: false,
      author: "",
      text: "",
      title: ""
    };
  },
  computed: {
    ...mapState(["currentDataset"])
  },
  methods: {
    openDialog() {
      this.dialog = true;

      this.graph = document.getElementById("graph");
      const matrix1 = document.getElementById("matrix1");
      const matrix2 = document.getElementById("matrix2");

      const matrixCombined = document.createElement("canvas");
      matrixCombined.width = matrix1.clientWidth;
      matrixCombined.height = matrix1.clientHeight;
      const ctx = matrixCombined.getContext("2d");

      ctx.drawImage(matrix1, 0, 0);
      ctx.drawImage(matrix2, 0, 0);

      this.matrix = matrixCombined;

      this.graphImage = this.graph.toDataURL("image/png");
      this.matrixImage = this.matrix.toDataURL("image/png");
    },
    saveInsight() {
      const { matrixImage, graphImage, author, text, title } = this;
      this.loading = true;
      this.$store
        .dispatch("saveInsight", {
          matrixImage,
          graphImage,
          author,
          text,
          title
        })
        .then(() => {
          this.loading = false;
          this.dialog = false;
          this.text = "";
          this.title = "";
        });
    }
  }
};
</script>
